using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid; 

namespace MasterDetail
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Label label2;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			Init();
			

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.label2 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(8, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(568, 400);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "Prevent-Plus Sign";
			this.gridDataBoundGrid1.ThemesEnabled = true;
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// label2
			// 
			this.label2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label2.Location = new System.Drawing.Point(8, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(568, 24);
			this.label2.TabIndex = 4;
			this.label2.Text = "prevent \"+\" sign that have no children";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 464);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private void Init()
		{
			DataSet ds = new DataSet();

			DataTable dtParent = GetParentTable();
			DataTable dtChild = GetChildTable();
			
			ds.Tables.Add(dtParent);
			ds.Tables.Add(dtChild);
			ds.Relations.Add("Parent_Child",ds.Tables[0].Columns["ParentID"],ds.Tables[1].Columns["ParentID"]);      
			
			gridDataBoundGrid1.Text = "Master-View";
			gridDataBoundGrid1.Binder.SetDataBinding(ds, "ParentTable");
			GridHierarchyLevel childrenLevel = gridDataBoundGrid1.Binder.AddRelation("Parent_Child");
			
			childrenLevel.ShowHeaders = false;
			
			
			gridDataBoundGrid1.Binder.RootHierarchyLevel.ShowHeaders = true;

			this.gridDataBoundGrid1.CellDrawn += new Syncfusion.Windows.Forms.Grid.GridDrawCellEventHandler(this.gridDataBoundGrid1_CellDrawn);
	

		}

		private int parentRows = 20;
		private int ChildRows = 30;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));

			for(int i = 0; i < parentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private Random r = new Random();

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < ChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = r.Next(parentRows).ToString();//(i % parentRows).ToString();
				dt.Rows.Add(dr);
			}
		
			return dt;
		}
	
		
		private void gridDataBoundGrid1_CellDrawn(object sender, Syncfusion.Windows.Forms.Grid.GridDrawCellEventArgs e)
		{
			if(e.ColIndex == 1)
			{
				int count = -1;
				int level = -1;
	
				if(!this.gridDataBoundGrid1.CurrentCell.IsEditing)
				{
					GridBoundRecordState state = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex);
					count = state.ChildCount;
					level =  state.LevelIndex; 

					//to get the valid child count, the row has to be expanded so the childlist is populated
					//here we do a 'silent' expand
					if(!this.gridDataBoundGrid1.IsExpandedAtRowIndex(e.RowIndex))
					{
						this.gridDataBoundGrid1.BeginUpdate();
						this.gridDataBoundGrid1.Model.SuspendChangeEvents();
						this.gridDataBoundGrid1.ExpandAtRowIndex(e.RowIndex);
						count = state.ChildCount;
						this.gridDataBoundGrid1.CollapseAtRowIndex(e.RowIndex);
						this.gridDataBoundGrid1.Model.ResumeChangeEvents();
						this.gridDataBoundGrid1.EndUpdate();
					}
				}
	
				if( count == 0 
					|| e.RowIndex == this.gridDataBoundGrid1.Model.RowCount 
					|| this.gridDataBoundGrid1.Binder.IsAddNew )
				{
					if( level  < 1 )
					{
						Brush brush = new SolidBrush(e.Style.BackColor);
						try
						{
							e.Graphics.FillRectangle(brush,e.Bounds);
							Rectangle centerRect = GridUtil.CenterInRect(e.Bounds,new Size(8,8));   
							e.Graphics.DrawRectangle(Pens.Black,centerRect);
							centerRect.Offset(0,-3); 
							e.Graphics.DrawString("-",e.Style.GdipFont,Brushes.Black,centerRect);      
							e.Cancel = true;
						}
						finally
						{
							brush.Dispose();
						}
					}

				}
			
				
			}

		}

		
	}
}
